// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// Z O M B I E   T O R R E N T   2
// MAIN DEBUGGING FILE
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 


script "KeyTest"
{
	SetFont(FNT_PLAIN);
	
	if (IsUnbound("zt2_changeperk"))
		Print(s:"BIND YOUR PERK KEY");
	else
		Print(s:"It is bound");
}


// ------------------------/
// Self-explanatory
// 0: Combat
// 1: Calm
// 2: Boss
// ------------------------/

script "TryPlayingSong" (int type)
{
	switch (type)
	{
		case 0:
		default:
			PlayCombatSong();
			break;
			
		case 1:
			PlayCalmSong();
			break;
			
		case 2:
			PlayBossSong();
			break;
	}
}

// ------------------------/
// Spawn a cinematic camera 
// pointing to our location
// ------------------------/

script "CinematicMe"
{
	// Attempt to spawn a camera for them
	int ang = GetActorAngle(0);
	int x = GetActorX(0);
	int y = GetActorY(0);
	int z = GetActorZ(0);
	
	SetFont(FNT_PLAIN);
	PrintBold(s:"[", f:x, s:", ", f:y, s:", ", f:z, s:"] ", f:ang);
	
	int cam = SpawnCinematicCameraForced(x, y, z, ang, ActivatorTID());
	if (cam)
		ChangeCamera(cam, 1, 0);
}

// ------------------------/
// Debug Perks
// ------------------------/

script "ListPerks" (void) NET CLIENTSIDE
{
	ZTPrint(StrParam(s:"Your Perk XP: ", d:CheckInventory("PerkXP"), s:" / ", d:GetAmmoCapacity("PerkXP")));
	for (int i=0; i<PerkListSize; i++)
	{
		ZTPrint(StrParam(s:PerkList[i].DisplayName, s:", ", d:PerkList[i].Hash, s:" (", d:CRC(PerkList[i].ID), s:")"));
	}
}

// ------------------------/
// Debug spawners
// ------------------------/

script "SpawnerDebug" (void) NET
{
	for (int i=0; i<spawnSpotsSize; i++)
	{
		if (spawnSpots[i].Pulses > 0)
			PrintBold(s:"YES");
		else
			PrintBold(s:"NO");
	}
	
	SpawnZombie();
}

// ------------------------/
// Debug players
// ------------------------/

script "PlayerDebug" (void) NET
{
	str debugString = "\cDPLAYER DEBUG:\n";
	debugString = StrParam(s:debugString, s:"\cIWE ARE PLAYER \cK", d:PlayerNumber(), s:"\n\n");
	
	for (int i=0; i<MAXPLAYERS; i++)
	{
		if (!PlayerInGame(i) && !PlayerIsSpectator(i))
			continue;
			
		str AliveString = PlayerState[i].Alive ? "\cDALIVE" : "\cGDEAD";
		str ReadyString = PlayerState[i].Ready ? "\cKREADY" : "\cINOT READY";
		
		str nameString = StrParam(n:i);
		
		debugString = StrParam(s:debugString, s:"\cJ", d:i, s:". ");
		debugString = StrParam(s:debugString, s:nameString, s:" - ", s:AliveString, s:" ", s:ReadyString, s:" - PERK: ", d:PlayerState[i].PerkIndex, s:"\n");
	}
	
	ZTAnnounce(debugString);
	Print(s:"\cDCheck console for results.");
}

// ------------------------/
// Debug traders
// ------------------------/

script "TraderDebug" (void) NET
{
	str debugString = "\cDTRADER DEBUG:\n";
	
	for (int i=0; i<TraderArraySize; i++)
	{
		debugString = StrParam(s:debugString, s:"\cJ", d:i, s:". ");
		debugString = StrParam(s:debugString, s:"\cKDoor ID: \cJ", d:TraderArray[i].DoorID);
		debugString = StrParam(s:debugString, s:" \Spot ID: \cJ", d:TraderArray[i].SpotID, s:"\n");
	}
	
	PrintBold(s:debugString);
}

// ------------------------/
// Benchmark function
// Executes a specific script over and over
// ------------------------/

script "Benchmark" NET
{
	int iterations = 0;
	str ScriptName = GetCVarString("cl_zt2benchmark");
	
	if (StrLen(ScriptName) <= 0)
	{
		PrintBold(s:"\cJBenchmark script not set, use \cKcl_zt2benchmark \cJto set one.");
		terminate;
	}
	
	PrintBold(s:"\cJPerforming benchmark on \cK", s:ScriptName, s:"\cJ...");
	
	while (iterations < BENCHMARK_ITERATIONS)
	{
		for (int l=0; l<BENCHMARK_BATCHSIZE; l++)
		{
			ACS_NamedExecuteAlways(ScriptName, 0);
			iterations ++;
		}
		
		delay(1);
	}
	
	PrintBold(s:"Script ", s:ScriptName, s:" run for ", d:BENCHMARK_ITERATIONS, s:" iterations.\nUse the ACSProfile command to check results.");
}

// ------------------------/
// Test for showing HUD messages
// ------------------------/
script "HUDTest"
{
	SetFont("BIOTIME1");
	HUDMessageUnscaled(64.0, 64.0, "a", ALIGN_LEFT, ALIGN_TOP, 100, 5.0);
	delay(35*2);
	
	SetFont("BIOTIME1");
	HUDMessageUnscaled(-64.0, 64.0, "a", ALIGN_RIGHT, ALIGN_TOP, 100, 5.0);
	delay(35*2);
	
	SetFont("BIOTIME1");
	HUDMessageUnscaled(64.0, -64.0, "a", ALIGN_LEFT, ALIGN_BOTTOM, 100, 5.0);
	delay(35*2);
	
	SetFont("BIOTIME1");
	HUDMessageUnscaled(-64.0, -64.0, "a", ALIGN_RIGHT, ALIGN_BOTTOM, 100, 5.0);
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

void ZTPrint(str msg) { Log(s:msg); }
void ZTAnnounce(str msg) 
{ 
	Log(s:msg);
	
	SetFont(FNT_PLAIN);
	PrintBold(s:msg); 
}