
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// Q U I C K   G R E N A D E
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

script "QuickGrenade" (void)
{
	if ( GrenadesLeft() <= 0 )
		terminate;
		
	// Are we currently holding it?
	int GI = GrenadeIndex();
	if (GI >= 0 && CheckWeapon(WeaponList[GI].Class))
		terminate;
		
	GiveInventory("QuickGrenading", 1);
	SetWeapon("Type97Grenade");
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// Q U I C K   S Y R I N G E
// SERVER
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

script "QuickSyringe" NET
{
	if (CheckInventory("QuickHealing") || !HealingAllowed())
		terminate;
		
	GiveInventory("QuickHealing", 1);
	SetWeapon("Syringe");
}

// ------------------------/
// Cleanup input-related things
// [SERVER]
// ------------------------/

void Input_Cleanup()
{
	InvEnsure("TryReloading", 0);
	InvEnsure("TryIronSights", 0);
}

// ------------------------/
// Handle buttons and whatnot
// ------------------------/

void Input_Tick()
{
	// Reload!
	if (ButtonPressed(BT_RELOAD))
		InvEnsure("TryReloading", 1);
		
	// ADS
	if (ButtonPressed(BT_ZOOM))
		InvEnsure("TryIronSights", 1);
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#define BINDING_COUNT 		6
#define BINDING_NAME		0
#define BINDING_COMMAND		1

str ZT2Bindings[BINDING_COUNT][2] = {
	{"Heal Self", "zt2_quicksyringe"},
	{"Quick Grenade", "zt2_quickgrenade"},
	{"Reload", "+reload"},
	{"Toggle ADS", "+zoom"},
	{"Fire", "+attack"},
	{"Secondary Fire", "+altattack"}
};

// ------------------------/
// Used for the lobby notification
// Check all keys and see if anything needs binding
//
// CLIENTSIDE
// ------------------------/

void Input_CheckBindings()
{
	int i;
	
	GameState.HUD.NeedsBinding = false;
	GameState.HUD.BindingString = "";
	
	for (i=0; i<BINDING_COUNT; I++)
	{
		if (IsUnbound(ZT2Bindings[i][BINDING_COMMAND]))
		{
			GameState.HUD.NeedsBinding = true;
			GameState.HUD.BindingString = StrParam(s:ZT2Bindings[i][BINDING_NAME], s:"\n", s:GameState.HUD.BindingString);
		}
	}
}